#------------------------------------------------------#
# Tur-Invite. A blatant ripoff from Dark0n3 =)         #
# Ripoff Version: 1.3                                  #
#------------------------------------------------------#
#                                                      #
# Right then. I wanted a invite bot only without the   #
# full dZSbot.tcl package so I took out the parts      #
# needed only for '/msg bot !invite user pw'.          #
#                                                      #
# It does not handle 'site invite' from inside ftp.    #
#                                                      #
# I added, with the help of s3x, some more announce    #
# lines for it the user is deleted and/or purged.      #
# So you cant invite yourself anymore if you are       #
# deleted on site (flag 6).                            #
#                                                      #
# subzero also added more functionality, namely invite #
# to other chans based on the group you are in. More   #
# on this below                                        #
#                                                      #
# You may update your current dZSbot.tcl with these    #
# functions by copying the 'set announce' for          #
# DELMSGINVITE and NOMSGINVITE.                        #
#                                                      #
# Also grab and overwrite the entire INVITE CHECK      #
# part.                                                #
#                                                      #
# However, if you want this on a standalone bot for    #
# invites only, edit the settings below. If you do not #
# have passchk already, compile the passchk.c with     #
# gcc -o passchk passchk.c                             #
#                                                      #
# Make sure all paths below are correct.               #
#                                                      #
# If you dont want it to say anything in the announce, #
# set that announce to ""                              #
#                                                      #
# Load it in your bots config file.                    #
#                                                      #
# I do not support this script cause I SUCK at tcl.    #
#                                                      #
#------------------------------------------------------#
#                                                      #
# New in 1.3 is: set chanlist(GROUP) "#chan"           #
# That means that if you are in the group GROUP, you   #
# will also be invited to the #chan channel as well    #
# as the DEFAULT channel.                              #
#                                                      #
# As you can see from the example, you can also add a  #
# custom invite message for the channels you define    #
# here, so if we use the above example, we get:        #
# set announce(#chan)        "-sitename- blabla"       #
#                                                      #
# will be announced in the #chan channel when a user   #
# in the group GROUP invites himself.                  #
# (note that its the channel you set as announce, not  #
# group).                                              #
#                                                      #
# Turranius / S3X / subzero - 2003.                    #
# http://www.grandis.nu/glftpd                         #
# http://grandis.mine.nu                               #
#                                                      #
#------------------------------------------------------#

set binary(PASSCHK)   "/bin/passchk"
set location(PASSWD)  "/glftpd/etc/passwd"
set location(USERS)   "/glftpd/ftp-data/users/"
set binary(CAT)       "/bin/cat"
set chanlist(DEFAULT) "#xXx"
set chanlist(STAFF)   "#xXx-STAFF"

set sitename          "xXx"

set announce(MSGINVITE)    "-%sitename- \[INVITE\] + %bold%user%bold@%group rides again as %bold%ircnick%bold"
set announce(BADMSGINVITE) "-%sitename- \[INTRUDER\] - %bold%ircnick%bold (%host) tried to invite himself with invalid login!"
set announce(DELMSGINVITE) "-%sitename- \[INTRUDER\] - %bold%ircnick%bold (%host) tried to invite himself but %ircnick is deleted!"
set announce(NOMSGINVITE)  "-%sitename- \[INTRUDER\] - %bold%ircnick%bold (%host) tried to invite himself but there is no such user!"
set announce(#xXx-STAFF)   "-%sitename- %bold%user%bold joined the discussion as %bold%ircnick%bold"

bind msg -|- !invite invite

set splitter(CHAR) "\n"


#################################################################################
# REPLACE WHAT WITH WITHWHAT                                                    #
#################################################################################
proc replacevar {strin what withwhat} {
 global zeroconvert

 set output $strin
 set replacement $withwhat

    if { [string length $replacement] == 0 && [info exists zeroconvert($what)] } { set replacement $zeroconvert($what) }
 set cutpos 0

    while { [string first $what $output] != -1 } {
	set cutstart [expr [string first $what $output] - 1]
	set cutstop  [expr $cutstart + [string length $what] + 1]
	set output [string range $output 0 $cutstart]$replacement[string range $output $cutstop end]
    }
 return $output
}
#################################################################################


#################################################################################
# CONVERT BASIC COOKIES TO DATA                                                 #
#################################################################################
proc basicreplace {strin section} {
 global sitename

    set output [replacevar $strin "%sitename" $sitename]
    set output [replacevar $output "%bold" "\002"]
    set output [replacevar $output "%uline" "\037"]
    set output [replacevar $output "%section" $section]
 return "$output"
}
#################################################################################


#################################################################################
# INVITE CHECK  Modified by Turranius/S3X                                       #
#################################################################################
proc invite { nick host hand arg } {
 global location binary chanlist announce

 if { [llength $arg] == 2 } {
  set username [lindex $arg 0]
  set password [lindex $arg 1]
  set result [exec $binary(PASSCHK) $username $password $location(PASSWD)]
  set group ""

  set userfile "$location(USERS)$username"

  if {![file exists $userfile]} then {
    set output $announce(NOMSGINVITE)
  } else {
    foreach line [split [exec $binary(CAT) $userfile] "\n"] {
      if { ! [string compare [lindex $line 0] "FLAGS"] } {
	set flags [lindex $line 1]
        break
      }
    }

    if {[string match "*6*" "$flags"]!="0"} {
      set result "DELLED"
    }

    if { ! [string compare $result "MATCH"] } {
      set output $announce(MSGINVITE)
	foreach line [split [exec $binary(CAT) $userfile] "\n"] {
	  if { ! [string compare [lindex "$line" 0] "GROUP"] } {
	    set group [lrange $line 1 end]
            break
	  }
	}
	foreach channel $chanlist(DEFAULT) { puthelp "INVITE $nick $channel" }
	foreach grp $group {
	  if { [info exists chanlist($grp)] } {
	    foreach channel $chanlist($grp) {
	      puthelp "INVITE $nick $channel"
	      if { [info exists announce($channel)] } {
	        set output2 $announce($grp)
                set output2 [replacevar "$output2" "%ircnick" $nick]
                set output2 [replacevar "$output2" "%user" $username]
                set output2 [replacevar "$output2" "%host" $host]
                set output2 [replacevar "$output2" "%group" $group]
                set output2 [basicreplace "$output2" "INVITE"]
                sndall "$grp" "$output2"
	      }
	    }
	  }
	}
    } else { if { ! [string compare $result "NOMATCH"] } {
      set output $announce(BADMSGINVITE)
    } else { if { ! [string compare $result "DELLED"] } {
      set output $announce(DELMSGINVITE)
    } else {
      set output $announce(BADMSGINVITE)
    }
    }
    }
  }

  set output [replacevar "$output" "%ircnick" $nick]
  set output [replacevar "$output" "%user" $username]
  set output [replacevar "$output" "%host" $host]
  set output [replacevar "$output" "%group" $group]
  set output [basicreplace "$output" "INVITE"]
  sndall "DEFAULT" "$output"
 }
}

#################################################################################
# SEND TO ALL CHANNELS LISTED                                                   #
#################################################################################
proc sndall {section args} {
 global chanlist splitter
 foreach chan $chanlist($section) {
  foreach line [split [lindex $args 0] $splitter(CHAR)] {
   putquick "PRIVMSG $chan :$line"
  }
 }
}
#################################################################################


putlog "Invite 1.0 by Turranius (Based on Dark0n3's sitebot) loaded"
